package com.sample;

 /* ************************************************************************
 * $RCSfile: INFCustomClassLoader.java,v $
 * $Revision: 1.1 $
 * Author : sbanik
 * Created on Jul 3, 2007
 * 
 *  Copyright 2007 THE GENERAL ELECTRIC COMPANY.
 * This software is the confidential and proprietary information of the
 * General Electric Company (GE). You shall not disclose this software and
 * shall use it only in accordance with the terms of the license agreement
 * you entered into with GE.
 *
 * $Log: INFCustomClassLoader.java,v $
 * Revision 1.1  2007/11/02 15:30:44  siddhartha
 * SPR # : SVCge42157
 * To load class files dynamically from a jar file which is not in class path.
 *
 * ************************************************************************/


import java.util.Hashtable;
import java.util.Map;

import org.drools.base.ShadowProxyFactory;





/**
 * This class loads a class only from the urls user has passed. This class loader does not deligates class loading
 * task to any parent class loader.
 * @author siddhartha
 *
 */

public class INFCustomClassLoader extends ClassLoader
{
	
	private Map<String, Class> classes = new Hashtable<String, Class>();
	
	public INFCustomClassLoader() 
	{
		super(INFCustomClassLoader.class.getClassLoader());
	}
		
	
	
	@SuppressWarnings("unchecked")
	public Class loadClass(String className) throws ClassNotFoundException
	{
		return findClass(className);
	}
	
	@SuppressWarnings("unchecked")
	protected Class findClass(String className) throws ClassNotFoundException
	{
		
		Class result = null;

		result = (Class) classes.get(className);
			
		if(result != null)
		{
			return result;
		}
		
		try
		{
			return findSystemClass(className);
			
		}
		catch(Exception e)
		{

		}
		
		
			
		if(className != null && className.endsWith("ShadowProxy"))
		{
			className = className.substring(0, className.indexOf("ShadowProxy"));
		//	System.out.println("--------->"+className);
			Class clazz = Class.forName(className);
			return ShadowProxyFactory.getProxy(clazz);
		}
		else
		{
			//System.out.println("Custom Class Loader Failed.");
			throw new ClassNotFoundException("Custom Class Loader Failed.");
		}
			
		
	}
	
	
	public void clear()
	{
		classes.clear();
	}
	


}
